#ifndef _H_ABC0380BFD72185BA200EE0A9F33604D_State__H_
#define _H_ABC0380BFD72185BA200EE0A9F33604D_State__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace lifecycle_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace State_Constants
            {
                const ::DDS::Octet PRIMARY_STATE_UNKNOWN_ = 0;

                const ::DDS::Octet PRIMARY_STATE_UNCONFIGURED_ = 1;

                const ::DDS::Octet PRIMARY_STATE_INACTIVE_ = 2;

                const ::DDS::Octet PRIMARY_STATE_ACTIVE_ = 3;

                const ::DDS::Octet PRIMARY_STATE_FINALIZED_ = 4;

                const ::DDS::Octet TRANSITION_STATE_CONFIGURING_ = 10;

                const ::DDS::Octet TRANSITION_STATE_CLEANINGUP_ = 11;

                const ::DDS::Octet TRANSITION_STATE_SHUTTINGDOWN_ = 12;

                const ::DDS::Octet TRANSITION_STATE_ACTIVATING_ = 13;

                const ::DDS::Octet TRANSITION_STATE_DEACTIVATING_ = 14;

                const ::DDS::Octet TRANSITION_STATE_ERRORPROCESSING_ = 15;

            }

            struct  State_
            {
                ::DDS::Octet id_;
                ::DDS::String_mgr label_;
            };

            typedef DDS_DCPSStruct_var<State_> State__var;
            typedef DDS_DCPSStruct_out < State_> State__out;

        }

    }

}

#endif /* _H_ABC0380BFD72185BA200EE0A9F33604D_State__H_ */
